# Contributing

The issue tracker is only for bug reports and enhancement suggestions.

If you wish to contribute to the Lucia codebase or documentation, feel free to fork the repository and submit a
pull request. We use Prettier to enforce a consistent coding style, so having that set up in your editor of choice
is a great boon to your development process.

## Setup

To get ready to work on the codebase, please do the following:

1. Clone the repository

   - **If you are a first-time contributor**: Fork the repository, and make sure you're on the **master** branch
   - **If you are a repository collaborator**: Checkout and create a new branch from **master**

2. Run `yarn`
3. Code your heart out!
4. [Submit a pull request](https://github.com/aidenybai/lucia/compare) (Make sure you follow the [conventional commit format](https://github.com/aidenybai/lucia/blob/master/.github/COMMIT_CONVENTION.md))

## Tips

- Common Scripts
  - **Build for development:** `yarn dev`
  - **Build for production:** `yarn build`
  - **Run all tests:** `yarn test`
  - **Prettier codebase:** `yarn cleanup`
- You can make `test*.html` (wildcard is anything) at root for ad-hoc testing.

## Lucia Core

Before contributing to Lucia's core, be sure to read this [markdown document](https://github.com/aidenybai/lucia/tree/master/src/core#readme).
